# costdoc.spec
# Common constructs for costdoc.
# Section numbers, cross-references.

require utils/Numerals.tcl

proc sectitle {} {
    withNode ancestor element SECT child element TITLE {
	return [content]
    }
    return ""
}

global _uniqueid ; set _uniqueid 0
proc uniqueid {} { global _uniqueid ; return [incr _uniqueid] }

proc setprops {} {
    foreachNode subtree {
	foreach prop [propspec get proplist ""] {
	    setprop $prop [subst [propspec get $prop]]
	}
    }
}

specification propspec {

    {elements "SECT APPENDIX"} {
	proplist "seclevel secnumber reflabel refnumber reftitle reftext"
	refnumber	{[join [query* rootpath propval secnumber] .]}
	reftitle	{[join [query* child element TITLE subtree content]]}
	reftext 	{[q propval refnumber]. \"[query propval reftitle]\"}
	seclevel	{[countq ancestor elements "SECT APPENDIX"]}
    }
    {element SECT} {
	secnumber 	{[childNumber]}
    }
    {element APPENDIX} {
	secnumber 	{[ucalpha [childNumber]]}
    }
    {elements "SECT APPENDIX" hasatt ID} {
	reflabel	{[query attval ID]}
    }

    {element REFENTRY} {
	proplist "refkey reftitle reftext"
	reftext	{\[[q propval refkey]\]}
	reftitle {[join [query* child element TITLE subtree content]]}
    }
    {element REFENTRY hasatt REFKEY} {
	refkey	{[query attval REFKEY]}
    }
    {element REFENTRY} {
	refkey {[childNumber]}
    }
    {el} { reflabel	{[query gi][uniqueid]} }
}

