# File: printtree.spec
# Sample event handler
# Prints an indented listing of the tree structure

global level; set level 0

proc main {} { printtree }

eventHandler printtree -global {
    START {
	indent $level;
	puts "<[query gi]>";
	incr level;
    }
    END {
	incr level -1;
	indent $level;
	puts "</[query gi]>";
    }
    CDATA   { indent $level; puts "\"[query content]\"" }
    SDATA   { indent $level; puts "|[query content]|" }
    RE      { #indent $level; puts "RE" }
    DATAENT { indent $level; puts "&[query ename];" }
}

proc indent {n} { 
    while {$n > 0} { puts stdout "   " nonewline; incr n -1 }
}
