/* stub main() for testing */

#include <stdlib.h>
#include <stdio.h>

#include "strmgt.h"
#include "esis.h"

int main(int argc, char *argv[])
{
    ESISStream ep;
    ESISEventType eventType;
    ESISNode nd;
    int evcount = 0;

    ep = estream_create(stdin);
    while ((eventType = estream_next(ep, &nd)) != EV_EOF) 
    {
	++evcount;
	switch (eventType) 
	{
	    case EV_EOF: 	printf("-END-\n");	break;
	    case EV_START:	printf("<%s>\n", esis_gi(nd));	break;
	    case EV_END:	printf("</%s>\n", esis_gi(nd));	break;
	    case EV_DATAENT:	printf("&%s;\n", esis_ename(nd));	break;
	    case EV_PI:		printf("<?%s>\n", esis_text(nd));	break;
	    case EV_CDATA:	printf("-%s\n", esis_text(nd));	break;
	    case EV_SDATA:	printf("|%s\n", esis_text(nd));	break;
	    case EV_RE:		printf("+RE\n");	break;
	    case EV_SDSTART:
	    case EV_SDEND:
	    case EV_ERROR:				break;
	}
    }
    estream_close(ep);

    fprintf(stderr,"Read %d events\n", evcount);

    return 0;
}
