/***********************************************************************
 *               Copyright (C) 1995 Joe English
 *                   Freely redistributable
 ***********************************************************************
 *
 * File:	stream.c
 * Author: 	Joe English
 * Created:	25 Feb 1995
 * Description: Routines to manage ESISStreams
 *
 * $Date: 95/11/29 15:12:15 $
 * $Revision: 1.5 $
 * $Locker:  $
 */

#ifndef lint
static char RCSId[] = "$Id: stream.c,v 1.5 95/11/29 15:12:15 joe Exp $";
#endif

#include <stdlib.h>
#include <stdio.h>
#include "project.h"
#include "strmap.h"
#include "pile.h"
#include "esis.h"
#include "esisp.h"

ESISStream estream_create(FILE *sgmls)
{
    ESISStream ep;

    ep = malloc(sizeof(*ep));	/* %%% check */
    ep->rdptr = ep->rootnode = ep->curnode = ep->wrptr = 0;
    ep->relations = 0;
    ep->sgmlsinput = sgmls;
    ep->datapile = pcreate();
    ep->pathno = 1;

    ep->rootnode = esis_open_node(ep,EN_SD);
    ep->rootnode->depth = 0;
    ep->rootnode->pathno = -1;
    ep->rdptr = ep->rootnode;
    ep->curnode = ep->rootnode;
    ep->wrptr = 0;

    return ep;
}

void estream_close(ESISStream ep)
{
    pdestroy(ep->datapile);
    /* %%% Free nodes ... */
    free(ep);
}

/*+++ Inquiry routines: 
*/
ESISNode estream_rootnode(ESISStream ep)
{
    return ep->rootnode;
}
