/***********************************************************************
 *                 Copyright (C) 1995 Joe English
 *                      Freely redistributable
 ***********************************************************************
 *
 * File:	strmgt.h
 * Author:	Joe English
 * Created:	6 Jan 1995
 * Description:	Miscellaneous string utilities.
 *
 * $Date: 96/01/16 12:46:21 $
 * $Revision: 1.4 $
 * $Locker:  $
 */

#ifndef STRMGT_H
#define STRMGT_H 1

/* Constant strings, identifiers: */
/* %%% rename: strintern, strinternlc, strinternuc */
extern const char * intern(const char *);
extern const char * lcintern(const char *);
extern const char * ucintern(const char *);

extern int tokmatch(const char *token, const char *list);
extern int tokmatchic(const char *token, const char *list);
extern int tokcmpic(const char *, const char *);
extern char *savestring(const char *s);		/* returns: malloc'ed copy */

/* Dynamic strings: (%%% NYI; needed?)  */

typedef struct DString *DString;

extern DString	dstrcreate	(char *str);
	/* create a DString from a terminated string */
extern DString	dstrncreate	(char *str, int n);
	/* create a DString from a counted string */
extern void 	dstrdestroy	(DString);

/* Modifiers: */
extern void	dstrcat		(DString, char *);
extern void	dstrncat	(DString, char *, int n);
extern void	dstrcpy		(DString, char *);
extern void	dstrncpy	(DString, char *, int n);

/* Inquiry: */
extern char *	dstrval		(const DString);
extern int	dstrlen		(const DString);
extern int	dstrcmp		(const DString, const char *);
extern int	dstrcasecmp	(const DString, const char *);

/* DString->Dstring operations: */
extern void	dstring_append	(DString, const DString);

/* Modifiers: */
extern void	dstring_trunc	(DString, int len);
extern void	dstring_trunc	(DString, int len);

extern void	dstring_trim	(DString, const char *cc);
extern void	dstring_trimleft	(DString, const char *cc);
extern void	dstring_trimright	(DString, const char *cc);

extern DString	dstring_range	(const DString, int from, int to);

#endif /* STRMGT_H */

