/***********************************************************************
 *               Copyright (C) 1995 Joe English
 *                   Freely redistributable
 ***********************************************************************
 *
 * File:	tclcost.h
 * Author:	Joe English
 * Created:	Feb 1995
 * Description:	Bag of declarations, misc. macros.
 *
 * $Date: 95/11/29 15:12:28 $
 * $Revision: 1.9 $
 * $Locker:  $
 */


#ifndef TCLCOST_H
#define TCLCOST_H 1

#ifndef COSTGLOBAL
#define COSTGLOBAL extern
#define INIT(x)
#else
#define INIT(x)	= (x)
#endif

COSTGLOBAL ESISNode current_node INIT(0);
COSTGLOBAL ESISStream current_document INIT(0);

/*+++
 * Convenience macros:
 */

#define CMDPROC(name) \
int name(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])

#define CHECKNARGS(nargs,argusage) \
    if (argc != nargs+1) { \
	Tcl_AppendResult(interp, "wrong #args\n", NULL); \
	Tcl_AppendResult(interp, "Usage: ", argv[0], " ", argusage, NULL); \
	return TCL_ERROR; \
    }

#define CHECKCURNODE \
    if (!current_node) { \
	fprintf(stderr,"%s: no current node\n", argv[0]); \
	return TCL_ERROR; }


/*+++
 * Cost routines:
 */

extern int CostEval(Tcl_Interp *interp, ESISNode nd, char *expr);

typedef struct CQAssoc *CQAssoc, CQAssocRec;

extern CQAssoc assocConstructor(Tcl_Interp *interp, char *str);
extern void assocDestructor(void *);
extern CMDPROC(assocProc);

/*+++ External commands:
*/
extern CMDPROC(DefineSubstProc);
extern CMDPROC(DefineEnvironmentProc);

/*+++ Initialization:
*/
extern int Cost_Init(Tcl_Interp *interp);

#endif /*TCLCOST_H*/
