#
# Simple.tcl --
#	Simple, one-pass translation module for Cost 2.
#
# $Revision: 1.4 $

global translateSpec 
set translateSpec "translate"

environment translateEnv  \
	cdataFilter identity  \
	sdataFilter identity

proc identity {text}	{ return $text }
proc output {text}	{ puts stdout $text nonewline }

eventHandler translateHandler -global {
    START {
	output [subst [$translateSpec get before ""]]
	translateEnv save
	foreach param {cdataFilter sdataFilter} {
	    if [$translateSpec has $param] {
		translateEnv set $param [$translateSpec get $param]
	    }
	}
	$translateSpec do startAction
	output [subst [$translateSpec get prefix ""]]
    }
    END { 
	output [subst [$translateSpec get suffix ""]]
	$translateSpec do endAction
	translateEnv restore
	output [subst [$translateSpec get after ""]]
    }
    CDATA	{ output [[translateEnv get cdataFilter] [query content]] }
    RE  	{ output [[translateEnv get cdataFilter] "\n"] }
    SDATA	{ output [[translateEnv get sdataFilter] [query content]] }
}

proc main {} { translateHandler }

